
-- Not yet a real Lib
-- Based on Iriels StateActionTest

local AceOO = AceLibrary("AceOO-2.0");
local REFRESH_TIME = 0.25;


CPala.Class.BaseBar = AceOO.Class();

CPala.Class.BaseBar.prototype.name = nil;
CPala.Class.BaseBar.prototype.buttons = nil;
CPala.Class.BaseBar.prototype.frame = nil;
CPala.Class.BaseBar.prototype.arg1 = nil;
CPala.Class.BaseBar.prototype.arg2 = nil;
CPala.Class.BaseBar.prototype.type = nil;

--Creates The Basic Parts
--name = The Name of the New Bar (used for frame names)
function CPala.Class.BaseBar.prototype:init(name)
  	CPala.Class.BaseBar.super.prototype.init(self) -- very important. Will fail without this.

  	self.name = name;
   	self.buttons = {};
	self.arg1 = 50;
	self.arg2 = 360;
	self.type = "ROUND";

	local p = CreateFrame("Frame", name .. "Header", UIParent, "SecureStateHeaderTemplate");
	p:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 0);
	p:SetAttribute("statebindings", "0:^wait;1:top;2:nounit");
    	--p:SetAttribute("statemap-anchor", "1:0");
    self.frame = p;

    p:SetAttribute("state", "1"); -- default visible
end

--[[
function CPala.BaseBar.prototype:init(name, key, delay)
  	CPala.BaseBar.super.prototype.init(self) -- very important. Will fail without this.
  	self.name = name;
	self.key = key;
    ChatFrame1:AddMessage("Init Base");
	local p = CreateFrame("Frame", nil, UIParent, "SecureStateHeaderTemplate");
	-- Set up the parent to appear over the cursor when entering state 1
	p:SetAttribute("headofsx", "1:0");
	p:SetAttribute("headofsy", "1:0");
	p:SetAttribute("headofsrelpoint", "cursor");
	p:SetAttribute("statebindings", "0:^wait;1:top;2:nounit");
    p:SetAttribute("statemap-anchor", "1:0");
 	if (delay) then
		p:SetAttribute("delaystatemap-anchor", "1:0");
		p:SetAttribute("delaytimemap-anchor", "1:0.5");
		p:SetAttribute("delayhovermap-anchor", "1:true");
	end;
	self.frame = p;


	-- A child button that simply controls the launch keybinding
	--Maybe Split this to be able to add other posibilites of menu opening?
	local k = CreateFrame("Button", name .. "KeyFrame", nil, "CMenuKeyFrameTemplate");
	k:SetWidth(1);
	k:SetHeight(1);
	k:SetPoint("TOPLEFT", nil, "TOPLEFT", 0, 0);
	k:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	k:SetAttribute("showstates", "*");
	k:SetAttribute("*newstate1", "1");
	k:SetAttribute("*newstate2", "0");
    if (delay) then
		k:SetAttribute("delaystate", "0");
		k:SetAttribute("delaytime", delay);
		k:SetAttribute("delayhover", "all");
    end
	k:SetAttribute("bindings-wait", key);
	k:SetAttribute("bindings-top", "ESCAPE:RightButton");
	p:SetAttribute("AddChild", k);


    p:SetAttribute("state", 0);
end  ]]

--Add A New Button
--[[function CPala.Class.BaseBar.prototype:AddButton(name, key, static)
  	local btnCount = #self.buttons + 1
    	local b = CreateFrame("Button", self.name .. "Button" .. btnCount, nil, "CMenuButtonTemplate");
         tinsert(self.buttons, b);

         b.title:SetText(name);
         b:SetWidth(32);
    	b:SetHeight(32);
    	if (test) then

    		b:SetAttribute("showstates", "1,2");
		else
		    b:SetAttribute("showstates", "1,2");
		end;
		if (static) then
    		b:SetAttribute("newstate", "1:1;2:2");
		else
		    b:SetAttribute("newstate", 0);
		end;
		b:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp");
        b:SetAttribute("bindings-top", key);
        b:SetAttribute("bindings-nounit", key);
       	b:SetAttribute("anchorchild", self.frame);
   		self.frame:SetAttribute("AddChild", b);
        b:SetAttribute("statebutton", "1:LeftButton;2:RightButton")

		--New Button Need to Update All
        self:UpdateButtonPosition();

		b.number:SetText(key);

        return btnCount;
end ]]

function CPala.Class.BaseBar.prototype:AddButton(type)
	local btnCount = #self.buttons + 1;
    local b = type:new(self.name .. "Button" .. btnCount);
    tinsert(self.buttons, b.frame);
	b.frame.obj = b;
    self:UpdateButtonPosition();
    return b;
end;
--[[
function CPala.Class.BaseBar.prototype:SetButtonActionMulti(button, type, id, type2, id2, texture, unit)

         b = self.buttons[button];
         if (not b) then
         	return;
         end;

         --Delete Posible Old Options
         --TODO

         --Set New Options
         b.unit = unit;
         b:SetAttribute("unit", unit);
         b:SetAttribute("harmbutton", "harm");
    	 b:SetAttribute("type-harm", type);
   	     b:SetAttribute(type .. "-harm", id);
   	     b:SetAttribute("checkselfcast",true);

   		b:SetAttribute("helpbutton", "help");
    	b:SetAttribute("type-help", type2);
    	b:SetAttribute(type2 .. "-help", id2);

         if (texture) then
        	b.texture:SetTexture(texture);
			b.texture:Show();
         else
         	if (type == "macro") then
                self.error:Show();
                self.number:SetTextColor(1, 1, 1);
                local index = GetMacroIndexByName(id);
                local _, texture = GetMacroInfo(index)
                b:SetAttribute("type-harm", "macro");
                b:SetAttribute("macro-harm", tostring(id));
              	if (texture) then
              		self.texture:SetTexture(texture);
                    self.texture:Show();
              	else
              		self.texture:Hide();
               	end;

               	self.error:Show();
                self.number:SetTextColor(1, 1, 1);
                index = GetMacroIndexByName(id2);
                _, texture = GetMacroInfo(index)
                b:SetAttribute("type-help", "macro");
                b:SetAttribute("macro-help", tostring(id));
              	--if (texture) then
              	--	self.texture:SetTexture(texture);
                --    self.texture:Show();
              	--else
              	--	self.texture:Hide();
               	--end;
            else
         		b:SetScript("OnShow", childOnShow);
               	b:SetScript("OnUpdate", childOnUpdate);
            end;
         end;

         local t = b:GetAttribute("unit", unit)
end;

local function changeattr(arg1, arg2, arg3)
		if (not arg1) or type(arg1) == "table"	 then arg1 = "arg1"; end;
		if (not arg2) 	then arg2 = "arg2";  end;
		if (not arg3) 	then arg3 = "arg3"; end;
	    ChatFrame1:AddMessage("OnChange ".. arg2 .. " "..arg3);
end

]]


function CPala.Class.BaseBar.prototype:VisibleOnlyForUnit(unit, visible)
	if (unit) then
    		self.frame:SetAttribute("unit", unit);
    		--self.frame:SetAttribute("headstateunit", unit);
    		if (visible) then
        			RegisterUnitWatch(self.frame, true);
        			self.frame:SetAttribute("statemap-unitexists-false", "1:2");
        			self.frame:SetAttribute("statemap-unitexists-true", "2:1;0:0");
        		else
        			RegisterUnitWatch(self.frame);
        		end;
    	else
       		UnregisterUnitWatch(self.frame);
    	end;
end;


--Arranges The Buttons in a Cycle
function CPala.Class.BaseBar.prototype:UpdateButtonPosition(type, arg1, arg2)

	if not type then
	    type = self.type;
	else
	    self.type = type;
	end;

 	if not arg1 then
	    arg1 = self.arg1;
	else
	    self.arg1 = arg1;
	end;

	if not arg2 then
	    arg2 = self.arg2;
	else
	    self.arg2 = arg2;
	end;


	if (type == "ROUND") then
         local btnCount = #self.buttons;
         local b, angle, x, y;
         for i = 1, btnCount do
            local b = self.buttons[i];
            local angle;
            if arg2 >= 360 then
            	angle = rad( (i - 1) * (360 / (btnCount)) );
			else
            	angle = rad( (i - 1) * (arg2 / (btnCount - 1)) );
            end
    		y = math.sin(angle) * arg1;
    		x = math.cos(angle) * arg1;
    		b:SetAttribute("ofsx", -x);
    		b:SetAttribute("ofsy", y);
         end;
	elseif (type == "ROW") then
       	 local btnCount = #self.buttons;
         local b, x, y;
         x = 0;
         y = 0;
         for i = 1, btnCount do
            local b = self.buttons[i];
    		b:SetAttribute("ofsx", x);
    		b:SetAttribute("ofsy", y);
    		x = x + arg1;
			y = y + arg2;
         end;
	end;
end;


function CPala.Class.BaseBar.prototype:SetButtonScale(scale)
    local btnCount = #self.buttons;
    for i = 1, btnCount do
        local b = self.buttons[i];
            b:SetScale(scale);                 
    end;
end;