-- CursorBar Class

local AceOO = AceLibrary("AceOO-2.0");

CPala.Class.CursorBar = AceOO.Class(CPala.Class.BaseBar)
CPala.Class.CursorBar.prototype.keyFrame = nil;
CPala.Class.CursorBar.prototype.keyFrame2 = nil

--Creates The Basic Parts
function CPala.Class.CursorBar.prototype:init(name, delay, toggle)
  	CPala.Class.CursorBar.super.prototype.init(self, name) -- very important. Will fail without this.

	local p = self.frame;
    --self.name = name;

   	--local p = CreateFrame("Frame", nil, UIParent, "SecureStateHeaderTemplate");
	-- Set up the parent to appear over the cursor when entering state 1
	p:SetAttribute("headofsx", "1:0");
	p:SetAttribute("headofsy", "1:0");
	p:SetAttribute("headofsrelpoint", "cursor");
	--p:SetAttribute("statebindings", "0:^wait;1:top;2:nounit");
    --p:SetAttribute("statemap-anchor", "1:0");
 	if (delay) then
		p:SetAttribute("delaystatemap-anchor", "1:0");
		p:SetAttribute("delaytimemap-anchor", "1:" .. delay);
		p:SetAttribute("delayhovermap-anchor", "1:true");
	end;
	--self.frame = p;


	-- A child button that simply controls the launch keybinding
	--Maybe Split this to be able to add other posibilites of menu opening?
	local k = CreateFrame("Button", name .. "KeyFrame", nil, "CMenuKeyFrameTemplate");
	k:SetWidth(1);
	k:SetHeight(1);
	k:SetPoint("TOPLEFT", nil, "TOPLEFT", 0, 0);
	k:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	k:SetAttribute("showstates", "*");
	k:SetAttribute("*newstate1", "1");
	k:SetAttribute("*newstate2", "0");
    if (delay) then
		k:SetAttribute("delaystate", "0");
		k:SetAttribute("delaytime", delay);
		k:SetAttribute("delayhover", "all");
    end
	--k:SetAttribute("bindings-wait", key);
	--k:SetAttribute("bindings-top", "ESCAPE:RightButton");
	p:SetAttribute("AddChild", k);
	self.keyFrame = k;

 	if (toggle) then
		--a child Button that controls closing without delay
    	local b = CreateFrame("Button", self.name .. "KeyFrame2", nil, "CMenuKeyFrameTemplate");
    	b:SetWidth(1);
    	b:SetHeight(1);
    	b:SetPoint("TOPLEFT", nil, "TOPLEFT", 0, 0);
    	b:SetAttribute("showstates", "*");
    	b:SetAttribute("newstate", 0);
    	--b:SetAttribute("bindings-top", key);
		b:SetAttribute("anchorchild", self.frame);
		p:SetAttribute("AddChild", b);
		self.keyFrame2 = b;
	end;

    p:SetAttribute("state", 0);
end

function CPala.Class.CursorBar.prototype:SetKey(key)
	self.keyFrame:SetAttribute("bindings-wait", key)
	self.keyFrame:SetAttribute("bindings-top", "ESCAPE:RightButton");
	--self.frame:SetAttribute("AddChild", self.keyFrame);
	if (self.keyFrame2) then
        self.keyFrame2:SetAttribute("bindings-top", key)
	end;
	self.frame:SetAttribute("state", 0);
end;